

#include "ds.h"


extern export_sym_t module_symtab[];
static symtab_handler_t st_module = {
	{ "sym/module_example",
	  0,
	  0x00010000,
	  0,
	  NMMGR_TYPE_SYMTAB,
	  NMMGR_LIST_INIT },
	module_symtab
};




static int builtin_test(int argc, char *argv[]) { 
     
    if(argc == 1) {
        ds_printf("Usage: test file.dat\n");
        return CMD_NO_ARG; 
    } 
    
    char fn[MAX_FN_LEN];
    makeabspath(fn, argv[1], MAX_FN_LEN);
    
	if(FileExists(fn)) {
		ds_printf("DS_OK: File %s exists\n", fn);
		return CMD_OK; 
	} else {
		ds_printf("DS_ERROR: File %s not exists\n", fn);
		return CMD_ERROR; 
	}
    
    return CMD_OK; 
}



const char * lib_get_name() {
      return "module_example";
}


uint32 lib_get_version() {
       return DS_MAKE_VER(1, 0, 0);
}


int lib_open(klibrary_t * lib) {
    AddCmd("test", "Test command", (CmdHandler *) builtin_test); 
	return nmmgr_handler_add(&st_module.nmmgr);
}


int lib_close(klibrary_t * lib) {
	RemoveCmd(GetCmdByName("test"));
    return nmmgr_handler_remove(&st_module.nmmgr); 
}


// Export Test
void TestFunctionForExport() {
     ds_printf("Hello from exported function!\n"); 
}
