/* KallistiOS ##version##

   kos/elf.h
   Copyright (C)2000,2001,2003 Dan Potter

   $Id: elf.h,v 1.3 2003/08/02 23:08:36 bardtx Exp $
   
   DreamShell elf

*/


#include <sys/cdefs.h>
#include <arch/types.h>



/* Kernel-specific definition of a loaded ELF binary */
typedef struct cmd_elf_prog {
	void	*data;		/* Data block containing the program */
	uint32	size;		/* Memory image size (rounded up to page size) */

	/* Elf exports */
	ptr_t	main;

} cmd_elf_prog_t;


/* Load an ELF binary and return the relevant data in an cmd_elf_prog_t structure. */
cmd_elf_prog_t *cmd_elf_load(const char *fn);


/* Free a loaded ELF program */
void cmd_elf_free(cmd_elf_prog_t *prog);



