/****************************
 * DreamShell ##version##   *
 * events.h                 *
 * DreamShell events        *
 * Created by SWAT          *
 ****************************/     
#ifndef _DS_EVENTS_H
#define _DS_EVENTS_H


#include "video.h"

#define EVENT_STATE_ACTIVE 0
#define EVENT_STATE_SLEEP 1


typedef void Event_func(SDL_Event *, int);

typedef struct Event {

    const char *name;
    int id;
    Event_func *event;
    int state;
    int always;
       
} Event_t;




int InitEvents();
void ShutdownEvents();

Event_t *AddEvent(const char *name, Event_func *event, int always);
int RemoveEvent(Event_t *e);

int SetEventState(Event_t *e, int state);


Item_list_t *GetEventList();
Event_t *GetEventById(int id);
Event_t *GetEventByName(const char *name);


void PushEvents(SDL_Event *event, int ext);
void ProcessEvents(SDL_Event *event);



void VKB_Init();
void VKB_Shutdown();
void ToggleVKB();
void VKB_Event(SDL_Event *event);
void VKB_Draw();


#endif
