/****************************
 * DreamShell ##version##   *
 * video.h                  *
 * DreamShell video         *
 * Created by SWAT          *
 ****************************/ 
     
#ifndef _DS_VIDEO_H
#define _DS_VIDEO_H


#ifdef DS_ARCH_PSP

#include "SDL.h"
#include "SDL_main.h"
#include "SDL_thread.h"
#include "SDL_mutex.h"
#include "SDL_image.h"
#include "SDL_console.h"
#include "DT_drawtext.h"


#elif DS_ARCH_DC

#include <kos.h>
//#include <GL/gl.h>
//#include <GL/glu.h>
//#include <GL/kglx.h>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_dreamcast.h>
#include "SDL/SDL_Primitives.h"
#include "SDL/SDL_console.h"
#include "SDL/DT_drawtext.h"
#include "gui.h"
#include <GL/gl.h>
#include <GL/glu.h>

#else 

#include "SDL.h"
#include "SDL_thread.h"
#include "SDL_mutex.h"
#include "SDL_image.h"
#include "SDL_console.h"
#include "DT_drawtext.h"
#include "gui.h"
//#include <SDL/SDL.h>
//#include <SDL/SDL_image.h>

#endif


// Pixel packing macro
#define PACK_PIXEL(r, g, b) ( ((r & 0xF8) << 8) | ((g & 0xFC) << 3) | (b >> 3) )




SDL_Surface *GetScreen();
void SetScreen(SDL_Surface *new_screen);


void InitVideoLocker();
void ShutdownVideoLocker();

void LockVideo();
void UnLockVideo();


int InitVideo(int w, int h, int bpp);
void ShutdownVideo();

void ShowIMG(char *fn, int x, int y, int delay, int fade);

void bf_print(int x, int y, char *str);


void ShowLogo();
void HideLogo();
void FreeLogo();


#endif

